

;--- Compiler configuration:
#option Explicit

;--- Config serial port for BlHeli-Telemetry once:
;    (Priority lower than serial library; so softserial1.h
;     can overwrite port-wide settings to input.)
#startup BlHeliInit, 60


Sub BlHeliInit()

  ;--- Config serial UART channel 1 for receiving BLHeli-Data:
  #define SER1_BAUD 115200         ; 115200 baud
  #define SER1_DATABITS 8          ; 8 databits
  #define SER1_STOPBITS 1          ; 1 stopbit
  #define SER1_INVERT Off          ; ttl polarity
  #define SER1_RXNOWAIT Off        ; wait for stopbit (blocking receive)
  ; Config I/O ports for receiving BLHeli-Data:
  #define SER1_RXPORT BLHELI_PORT  ; user config (see top of main file)
  #define SER1_RXPIN  BLHELI_PIN   ;

End Sub


Sub BLHeliReceive()
; Gets one dataframe from BLHeli ESC:

  Dim bByteNr, bNoStart As Byte

  'Set LED Off

  ;Make shure, that we don't jump inside a dataframe:
  bNoStart = 0
  Do
    bNoStart += 1
    If SER1_RXPORT.SER1_RXPIN = 0 Then bNoStart = 0 'Restart loop, if a startbit is detected
  Loop Until bNoStart = 255

  ;Get 10 bytes:
  For bByteNr = 1 to 10
    BLHeliFrame(bByteNr) = Ser1Receive
  Next bByteNr

  ;Get BlHeli CRC-Checksum:
  BLHeliCrc()

End Sub


Sub BLHeliCrc()
; Calculates 8bit CRC checksum from byte1 to byte9:

  Dim bByteNr As Byte

  bCrc8B = 0
  For bByteNr = 1 To 9
    bCrc8B = bCrc8B Xor BLHeliFrame(bByteNr)
    Repeat 8
      If bCrc8B.7 = 1 Then
        bCrc8B = (bCrc8B * 2) Xor 7
       Else
        bCrc8B = bCrc8B * 2
      End If
    End Repeat
  Next bByteNr

End Sub
